SystemOrganization addCategory: #'SqueakNxt-EtoysCompiler'!

RBProgramNodeVisitor subclass: #NxtPlayerTranslator
	instanceVariableNames: 'programName motors sensors source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-EtoysCompiler'!

!NxtPlayerTranslator methodsFor: 'visiting' stamp: 'Richo 1/4/2011 11:42'!
acceptMessageNode: aMessageNode
	"Reemplazar selector con selector apropiado y receiver por self. Arguments?"
	(SqueakNxtPlayer selectors includes: aMessageNode selector) ifTrue: [
	(self rules at: aMessageNode selector) value: aMessageNode.
	aMessageNode receiver: (RBVariableNode named: 'self')].
	super acceptMessageNode: aMessageNode! !

!NxtPlayerTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 1/4/2011 10:46'!
compileSetUpMethod
| methodSource |
methodSource := WriteStream on: ''.
methodSource nextPutAll: 'setUp'; cr.
sensors doWithIndex: [:morph :index |
	morph isNil ifFalse: [ | zeroBasedIndex |
		zeroBasedIndex := (index - 1) asString.
		methodSource nextPutAll: 'self setSensor'.
		morph device type caseOf: {
			[SensorType lowspeed9V] -> [methodSource nextPutAll: 'LowSpeed: ', zeroBasedIndex].
			[SensorType lightActive] -> [methodSource nextPutAll: 'Light: ', zeroBasedIndex, ' active: true'].
			[SensorType lightInactive] -> [methodSource nextPutAll: 'Light: ', zeroBasedIndex, ' active: false'].
			[SensorType soundDba] -> [methodSource nextPutAll: 'Sound: ', zeroBasedIndex, ' scaling: false'].
			[SensorType soundDb] -> [methodSource nextPutAll: 'Sound: ', zeroBasedIndex, ' scaling: true'].
			[SensorType switch] -> [methodSource nextPutAll: 'Touch: ', zeroBasedIndex]
		} otherwise: [].
		methodSource nextPut: $.; cr.
	]
].
self programClass compileSilently: methodSource contents classified: 'setUp'! !

!NxtPlayerTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 1/4/2011 09:58'!
connectedMorphToPort: aNxtPort 
^ (NxtPluggableDeviceMorph allSubInstances detect: [:morph |
	morph isInWorld and: [morph device port = aNxtPort]
] ifNone: [nil])! !

!NxtPlayerTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 1/4/2011 10:05'!
createNxtProgramSubclassNamed: aByteSymbol 
	NxtProgram subclass: aByteSymbol
		instanceVariableNames: ''
		instanceVariableTypes: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'NxtPrograms'! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/4/2011 11:39'!
indexFor: aVariableNode in: aCollection
	| index |
	index := 0.
	aCollection do: [:each | 
	index := index + 1.
(each notNil and: [each assuredPlayer uniqueNameForReference = aVariableNode token value]) ifTrue: [^self literal: index - 1]].
	^ self error: 'Index not found'! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/4/2011 11:23'!
literal: aLiteralObject
	^ RBLiteralValueNode value: aLiteralObject! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/4/2011 11:35'!
motorIndexFor: aVariableNode 
	| index |
	index := 0.
	motors do: [:each | 
	index := index + 1.
(each notNil and: [each assuredPlayer uniqueNameForReference = aVariableNode token value]) ifTrue: [^index]].
	^ self error: 'Index not found'! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/4/2011 10:08'!
programClass
	^ Smalltalk at: programName! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/4/2011 11:40'!
rules
^ {
#getIsPressed -> [:node | node arguments: {self indexFor: node receiver in: sensors}.
								node selector: #sensorBoolean:].
#playTone: -> [:node | node arguments add: (self literal: 200).
							node selector: #playTone:duration:].
#setPower: -> [:node | node arguments addFirst: (self indexFor: node receiver in: motors).
							node selector: #onFwd:speed:] 
} as: Dictionary! !

!NxtPlayerTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 1/4/2011 11:29'!
translateScriptsFrom: aLegoNxtMorph
	programName := (aLegoNxtMorph assuredPlayer uniqueNameForReference , 'Program') asSymbol.
	self createNxtProgramSubclassNamed: programName.
	motors := {self connectedMorphToPort: aLegoNxtMorph nxt portA.
				self connectedMorphToPort: aLegoNxtMorph nxt portB.
				self connectedMorphToPort: aLegoNxtMorph nxt portC}.
	sensors := {self connectedMorphToPort: aLegoNxtMorph nxt port1.
				self connectedMorphToPort: aLegoNxtMorph nxt port2.
				self connectedMorphToPort: aLegoNxtMorph nxt port3.
				self connectedMorphToPort: aLegoNxtMorph nxt port4}.
	self compileSetUpMethod.
	aLegoNxtMorph assuredPlayer class selectors do: [:each | | node |
		self visitNode: (node := (aLegoNxtMorph assuredPlayer class parseTreeFor: each)).
		self programClass compileSilently: node formattedCode classified: #scripts
		].
	^ self programClass.! !
